#pragma semicolon 1

#include <sourcemod>
#include <sdktools>
#include <cstrike>

new Handle:g_hDb = INVALID_HANDLE;

#define Pref "\x04[Z0G]\x01"

public Plugin:myinfo =   
{ 
	name = "Player Info Collecting", 
    author = "igodsewer", 
    description = "Collecting different info about players via MySQL", 
    version = "1.4", 
    url = "http://alliedmods.net" 
};

public OnPluginStart()
{
	db_setupDatabase();
	HookEvent("player_death", Event_PlayerDeath, EventHookMode_Pre);
	HookEvent("player_disconnect", Event_PlayerLeft);
}

public OnClientAuthorized(client, const String:auth[])
{
	// NEWS
	decl String:szSteamId[32];
	GetClientAuthString(client, szSteamId, 32);
	new String:ip[32];
	GetClientIP(client, ip, sizeof(ip), false);
	new time = GetTime();
	new String:name[255];
	GetClientName(client, name, sizeof(name));
	
	new String:Safename[(sizeof(name)*2)+1];
	SQL_EscapeString(g_hDb, name, Safename, sizeof(Safename));
	
	
	new String:check[255];
	Format(check, sizeof(check), "SELECT steamid FROM info WHERE steamid ='%s'", szSteamId);
	new Handle:checkq = SQL_Query(g_hDb, check); 
	
	if (checkq != INVALID_HANDLE)
	{
		if (SQL_FetchRow(checkq))    
		{
			new String:query[255];
			Format(query, sizeof(query),  "UPDATE info SET lastc = '%d', name = '%s' WHERE steamid ='%s';", time, Safename, szSteamId);
			SQL_Query(g_hDb, query);
			PrintToChat(client, "%s Информация о Вас успешно обновлена в БД!", Pref);		
		}
		else
		{
			new String:query[255];
			Format(query, sizeof(query),  "INSERT INTO info (steamid, firstc, lastc, name, ip) VALUES('%s', '%d', '%d', '%s', '%s');", szSteamId, time, time, Safename, ip);
			SQL_Query(g_hDb, query); 
			PrintToChat(client, "%s Отметка о Вас (Ник, IP, SteamID) успешно занесена в БД!", Pref);
		}
	}
}

public Action:Event_PlayerDeath(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "attacker"));
	new victim = GetClientOfUserId(GetEventInt(event, "userid"));
	decl String:szSteamId[32];
	GetClientAuthString(client, szSteamId, 32);
	decl String:szSteamIdv[32];
	GetClientAuthString(victim, szSteamIdv, 32);
	
	new String:kills[255];
	Format(kills, sizeof(kills), "UPDATE info SET kills = kills+1 WHERE steamid ='%s';", szSteamId);
	SQL_TQuery(g_hDb, SQL_CheckCallback, kills);
	
	new String:vics[255];
	Format(vics, sizeof(vics), "UPDATE info SET deaths = deaths+1 WHERE steamid ='%s';", szSteamIdv);
	SQL_TQuery(g_hDb, SQL_CheckCallback, vics);
	
	if (GetEventBool(event, "headshot"))
	{
		new String:hs[255];
		Format(hs, sizeof(hs), "UPDATE info SET hs = hs+1 WHERE steamid ='%s';", szSteamId);
		SQL_TQuery(g_hDb, SQL_CheckCallback, hs);
	}
	return Plugin_Continue;
}

public Action:Event_PlayerLeft(Handle:event, const String:name[], bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	// NEWS
	decl String:szSteamId[32];
	GetClientAuthString(client, szSteamId, 32);
	new time = GetTime();
	
	new String:leave[255];
	Format(leave, sizeof(leave), "UPDATE info SET lastdis = '%d' WHERE steamid ='%s';", time, szSteamId);
	SQL_TQuery(g_hDb, SQL_CheckCallback, leave); 
}

public db_setupDatabase()
{	
	decl String:szError[255];
	
	g_hDb = SQL_Connect("Info", false, szError, 255);
	
	if(g_hDb == INVALID_HANDLE)
	{
		return;
	}
	
	db_createTables();
}

public db_createTables()
{
	SQL_LockDatabase(g_hDb);
	SQL_FastQuery(g_hDb, "CREATE TABLE IF NOT EXISTS info (id VARCHAR(64) PRIMARY KEY AUTO_INCREMENT, lastdis VARCHAR(256), steamid VARCHAR(64), firstc VARCHAR(256), lastc VARCHAR(256), name VARCHAR(256), ip VARCHAR(256), kills VARCHAR(10), deaths VARCHAR(10), hs VARCHAR(10);");
	SQL_UnlockDatabase(g_hDb);
}

public SQL_CheckCallback(Handle:owner, Handle:hndl, const String:error[], any:data)
{
	if(hndl == INVALID_HANDLE)
	{
		LogError("%s Error inserting into database (%s)", Pref, error);
	}	
}
